diff a/src/hotspot/share/memory/metaspace/metaspaceReporter.cpp b/src/hotspot/share/memory/metaspace/metaspaceReporter.cpp
--- a/src/hotspot/share/memory/metaspace/metaspaceReporter.cpp
+++ b/src/hotspot/share/memory/metaspace/metaspaceReporter.cpp
@@ -37,10 +37,11 @@
 #include "memory/metaspace/metaspaceStatistics.hpp"
 #include "memory/metaspace/printCLDMetaspaceInfoClosure.hpp"
 #include "memory/metaspace/runningCounters.hpp"
 #include "memory/metaspace/virtualSpaceList.hpp"
 #include "memory/metaspaceUtils.hpp"
+#include "oops/compressedKlass.hpp"
 #include "runtime/os.hpp"
 
 namespace metaspace {
 
 static const char* describe_spacetype(Metaspace::MetaspaceType st) {
@@ -116,10 +117,13 @@
   out->print("Current GC threshold: ");
   print_human_readable_size(out, MetaspaceGC::capacity_until_GC(), scale);
   out->cr();
   out->print_cr("CDS: %s", (UseSharedSpaces ? "on" : (CDSConfig::is_dumping_static_archive() ? "dump" : "off")));
   Settings::print_on(out);
+#ifdef _LP64
+  CompressedKlassPointers::print_mode(out);
+#endif
 }
 
 // This will print out a basic metaspace usage report but
 // unlike print_report() is guaranteed not to lock or to walk the CLDG.
 void MetaspaceReporter::print_basic_report(outputStream* out, size_t scale) {
@@ -323,11 +327,11 @@
   out->cr();
   out->print("Waste (unused committed space):");
   // For all wastages, print percentages from total. As total use the total size of memory committed for metaspace.
   const size_t committed_words = RunningCounters::committed_words();
 
-  out->print("(percentages refer to total committed size ");
+  out->print(" (percentages refer to total committed size ");
   print_scaled_words(out, committed_words, scale);
   out->print_cr("):");
 
   // Print waste for in-use chunks.
   InUseChunkStats ucs_nonclass = cl._stats_total._arena_stats_nonclass.totals();
diff a/src/hotspot/share/memory/metaspace/metaspaceStatistics.cpp b/src/hotspot/share/memory/metaspace/metaspaceStatistics.cpp
--- a/src/hotspot/share/memory/metaspace/metaspaceStatistics.cpp
+++ b/src/hotspot/share/memory/metaspace/metaspaceStatistics.cpp
@@ -184,20 +184,16 @@
     print_scaled_words(st, _free_blocks_word_size, scale);
   }
 }
 
 #ifdef ASSERT
-
 void ArenaStats::verify() const {
   size_t total_used = 0;
   for (chunklevel_t l = chunklevel::LOWEST_CHUNK_LEVEL; l <= chunklevel::HIGHEST_CHUNK_LEVEL; l++) {
     _stats[l].verify();
     total_used += _stats[l]._used_words;
   }
-  // Deallocated allocations still count as used
-  assert(total_used >= _free_blocks_word_size,
-         "Sanity");
 }
 #endif
 
 // Returns total arena statistics for both class and non-class metaspace
 ArenaStats ClmsStats::totals() const {
diff a/src/hotspot/share/memory/metaspace/runningCounters.cpp b/src/hotspot/share/memory/metaspace/runningCounters.cpp
--- a/src/hotspot/share/memory/metaspace/runningCounters.cpp
+++ b/src/hotspot/share/memory/metaspace/runningCounters.cpp
@@ -23,19 +23,16 @@
  *
  */
 
 #include "precompiled.hpp"
 #include "memory/metaspace/chunkManager.hpp"
-#include "memory/metaspace/counters.hpp"
+#include "memory/metaspace/metaspaceContext.hpp"
 #include "memory/metaspace/runningCounters.hpp"
 #include "memory/metaspace/virtualSpaceList.hpp"
 
 namespace metaspace {
 
-SizeAtomicCounter RunningCounters::_used_class_counter;
-SizeAtomicCounter RunningCounters::_used_nonclass_counter;
-
 // Return reserved size, in words, for Metaspace
 size_t RunningCounters::reserved_words() {
   return reserved_words_class() + reserved_words_nonclass();
 }
 
@@ -68,15 +65,16 @@
 size_t RunningCounters::used_words() {
   return used_words_class() + used_words_nonclass();
 }
 
 size_t RunningCounters::used_words_class() {
-  return _used_class_counter.get();
+  const MetaspaceContext* context = MetaspaceContext::context_class();
+  return context != nullptr ? context->used_words() : 0;
 }
 
 size_t RunningCounters::used_words_nonclass() {
-  return _used_nonclass_counter.get();
+  return MetaspaceContext::context_nonclass()->used_words();
 }
 
 // ---- free chunks -----
 
 // Returns size, in words, of all chunks in all freelists.
diff a/src/hotspot/share/memory/metaspace/runningCounters.hpp b/src/hotspot/share/memory/metaspace/runningCounters.hpp
--- a/src/hotspot/share/memory/metaspace/runningCounters.hpp
+++ b/src/hotspot/share/memory/metaspace/runningCounters.hpp
@@ -25,21 +25,15 @@
 
 #ifndef SHARE_MEMORY_METASPACE_RUNNINGCOUNTERS_HPP
 #define SHARE_MEMORY_METASPACE_RUNNINGCOUNTERS_HPP
 
 #include "memory/allStatic.hpp"
-#include "memory/metaspace/counters.hpp"
 
 namespace metaspace {
 
 // This class is a convenience interface for accessing global metaspace counters.
-class RunningCounters : public AllStatic {
-
-  static SizeAtomicCounter _used_class_counter;
-  static SizeAtomicCounter _used_nonclass_counter;
-
-public:
+struct RunningCounters : public AllStatic {
 
   // ---- virtual memory -----
 
   // Return reserved size, in words, for Metaspace
   static size_t reserved_words();
@@ -63,14 +57,10 @@
   // Returns size, in words, of all chunks in all freelists.
   static size_t free_chunks_words();
   static size_t free_chunks_words_class();
   static size_t free_chunks_words_nonclass();
 
-  // Direct access to the counters.
-  static SizeAtomicCounter* used_nonclass_counter()     { return &_used_nonclass_counter; }
-  static SizeAtomicCounter* used_class_counter()        { return &_used_class_counter; }
-
 };
 
 } // namespace metaspace
 
 #endif // SHARE_MEMORY_METASPACE_RUNNINGCOUNTERS_HPP
diff a/src/hotspot/share/memory/metaspace/testHelpers.cpp b/src/hotspot/share/memory/metaspace/testHelpers.cpp
--- a/src/hotspot/share/memory/metaspace/testHelpers.cpp
+++ b/src/hotspot/share/memory/metaspace/testHelpers.cpp
@@ -52,27 +52,31 @@
   delete _lock;
 }
 
 MetaWord* MetaspaceTestArena::allocate(size_t word_size) {
   MutexLocker fcl(_lock, Mutex::_no_safepoint_check_flag);
-  return _arena->allocate(word_size);
+  MetaBlock result, wastage;
+  result = _arena->allocate(word_size, wastage);
+  if (wastage.is_nonempty()) {
+    _arena->deallocate(wastage);
+  }
+  return result.base();
 }
 
 void MetaspaceTestArena::deallocate(MetaWord* p, size_t word_size) {
   MutexLocker fcl(_lock, Mutex::_no_safepoint_check_flag);
-  return _arena->deallocate(p, word_size);
+  _arena->deallocate(MetaBlock(p, word_size));
 }
 
 ///// MetaspaceTestArea //////
 
 MetaspaceTestContext::MetaspaceTestContext(const char* name, size_t commit_limit, size_t reserve_limit) :
   _name(name),
   _reserve_limit(reserve_limit),
   _commit_limit(commit_limit),
   _context(nullptr),
   _commit_limiter(commit_limit == 0 ? max_uintx : commit_limit), // commit_limit == 0 -> no limit
-  _used_words_counter(),
   _rs()
 {
   assert(is_aligned(reserve_limit, Metaspace::reserve_alignment_words()), "reserve_limit (" SIZE_FORMAT ") "
                     "not aligned to metaspace reserve alignment (" SIZE_FORMAT ")",
                     reserve_limit, Metaspace::reserve_alignment_words());
@@ -101,11 +105,11 @@
   const ArenaGrowthPolicy* growth_policy = ArenaGrowthPolicy::policy_for_space_type(type, false);
   Mutex* lock = new Mutex(Monitor::nosafepoint, "MetaspaceTestArea_lock");
   MetaspaceArena* arena = nullptr;
   {
     MutexLocker ml(lock,  Mutex::_no_safepoint_check_flag);
-    arena = new MetaspaceArena(_context->cm(), growth_policy, &_used_words_counter, _name);
+    arena = new MetaspaceArena(_context, growth_policy, Metaspace::min_allocation_alignment_words, _name);
   }
   return new MetaspaceTestArena(lock, arena);
 }
 
 void MetaspaceTestContext::purge_area() {
@@ -122,7 +126,20 @@
 
 void MetaspaceTestContext::print_on(outputStream* st) const {
   _context->print_on(st);
 }
 
+size_t MetaspaceTestContext::used_words() const {
+  return _context->used_words_counter()->get();
+}
+
+size_t MetaspaceTestContext::committed_words() const {
+  assert(_commit_limiter.committed_words() == _context->committed_words(), "Sanity");
+  return _context->committed_words();
+}
+
+size_t MetaspaceTestContext::reserved_words() const {
+  return _context->reserved_words();
+}
+
 } // namespace metaspace
 
diff a/src/hotspot/share/memory/metaspace/testHelpers.hpp b/src/hotspot/share/memory/metaspace/testHelpers.hpp
--- a/src/hotspot/share/memory/metaspace/testHelpers.hpp
+++ b/src/hotspot/share/memory/metaspace/testHelpers.hpp
@@ -73,11 +73,10 @@
   const size_t _reserve_limit;
   const size_t _commit_limit;
 
   MetaspaceContext* _context;
   CommitLimiter _commit_limiter;
-  SizeAtomicCounter _used_words_counter;
 
   // For non-expandable contexts we keep track of the space
   // and delete it at destruction time.
   ReservedSpace _rs;
 
@@ -96,19 +95,20 @@
 
   // Accessors
   const CommitLimiter& commit_limiter() const { return _commit_limiter; }
   const VirtualSpaceList& vslist() const      { return *(_context->vslist()); }
   ChunkManager& cm()                          { return *(_context->cm()); }
+  MetaspaceContext* context() const           { return _context; }
 
   // Returns reserve- and commit limit we run the test with (in the real world,
   // these would be equivalent to CompressedClassSpaceSize resp MaxMetaspaceSize)
   size_t reserve_limit() const    { return _reserve_limit == 0 ? max_uintx : 0; }
   size_t commit_limit() const     { return _commit_limit == 0 ? max_uintx : 0; }
 
-  // Convenience function to retrieve total committed/used words
-  size_t used_words() const       { return _used_words_counter.get(); }
-  size_t committed_words() const  { return _commit_limiter.committed_words(); }
+  size_t used_words() const;
+  size_t committed_words() const;
+  size_t reserved_words() const;
 
   DEBUG_ONLY(void verify() const;)
 
   void print_on(outputStream* st) const;
 
diff a/src/hotspot/share/memory/universe.cpp b/src/hotspot/share/memory/universe.cpp
--- a/src/hotspot/share/memory/universe.cpp
+++ b/src/hotspot/share/memory/universe.cpp
@@ -378,12 +378,17 @@
 void Universe::genesis(TRAPS) {
   ResourceMark rm(THREAD);
   HandleMark   hm(THREAD);
 
   // Explicit null checks are needed if these offsets are not smaller than the page size
-  assert(oopDesc::klass_offset_in_bytes() < static_cast<intptr_t>(os::vm_page_size()),
-         "Klass offset is expected to be less than the page size");
+  if (UseCompactObjectHeaders) {
+    assert(oopDesc::mark_offset_in_bytes() < static_cast<intptr_t>(os::vm_page_size()),
+           "Mark offset is expected to be less than the page size");
+  } else {
+    assert(oopDesc::klass_offset_in_bytes() < static_cast<intptr_t>(os::vm_page_size()),
+           "Klass offset is expected to be less than the page size");
+  }
   assert(arrayOopDesc::length_offset_in_bytes() < static_cast<intptr_t>(os::vm_page_size()),
          "Array length offset is expected to be less than the page size");
 
   { AutoModifyRestore<bool> temporarily(_bootstrapping, true);
 
diff a/src/hotspot/share/oops/arrayOop.hpp b/src/hotspot/share/oops/arrayOop.hpp
--- a/src/hotspot/share/oops/arrayOop.hpp
+++ b/src/hotspot/share/oops/arrayOop.hpp
@@ -80,12 +80,17 @@
 
   // The _length field is not declared in C++.  It is allocated after the
   // declared nonstatic fields in arrayOopDesc if not compressed, otherwise
   // it occupies the second half of the _klass field in oopDesc.
   static int length_offset_in_bytes() {
-    return UseCompressedClassPointers ? klass_gap_offset_in_bytes() :
-                               sizeof(arrayOopDesc);
+    if (UseCompactObjectHeaders) {
+      return oopDesc::base_offset_in_bytes();
+    } else if (UseCompressedClassPointers) {
+      return klass_gap_offset_in_bytes();
+    } else {
+      return sizeof(arrayOopDesc);
+    }
   }
 
   // Returns the offset of the first element.
   static int base_offset_in_bytes(BasicType type) {
     size_t hs = header_size_in_bytes();
diff a/src/hotspot/share/oops/compressedKlass.cpp b/src/hotspot/share/oops/compressedKlass.cpp
--- a/src/hotspot/share/oops/compressedKlass.cpp
+++ b/src/hotspot/share/oops/compressedKlass.cpp
@@ -23,104 +23,278 @@
  */
 
 #include "precompiled.hpp"
 #include "logging/log.hpp"
 #include "memory/metaspace.hpp"
-#include "oops/compressedKlass.hpp"
+#include "oops/klass.hpp"
+#include "oops/compressedKlass.inline.hpp"
 #include "runtime/globals.hpp"
+#include "runtime/java.hpp"
 #include "runtime/os.hpp"
 #include "utilities/debug.hpp"
 #include "utilities/globalDefinitions.hpp"
 #include "utilities/ostream.hpp"
 
-address CompressedKlassPointers::_base = nullptr;
-int CompressedKlassPointers::_shift = 0;
-size_t CompressedKlassPointers::_range = 0;
+int CompressedKlassPointers::_tiny_cp = -1;
+int CompressedKlassPointers::_narrow_klass_pointer_bits = -1;
+int CompressedKlassPointers::_max_shift = -1;
+#ifdef ASSERT
+address CompressedKlassPointers::_klass_range_start = (address)-1;
+address CompressedKlassPointers::_klass_range_end = (address)-1;
+narrowKlass CompressedKlassPointers::_lowest_valid_narrow_klass_id = (narrowKlass)-1;
+narrowKlass CompressedKlassPointers::_highest_valid_narrow_klass_id = (narrowKlass)-1;
+#endif
+
+address CompressedKlassPointers::_base = (address)-1;
+int CompressedKlassPointers::_shift = -1;
+size_t CompressedKlassPointers::_range = (size_t)-1;
+
+// The maximum allowed length of the Klass range (the address range engulfing
+// CDS + class space) must not exceed 32-bit.
+// There is a theoretical limit of: must not exceed the size of a fully-shifted
+// narrow Klass pointer, which would be 32 + 3 = 35 bits in legacy mode;
+// however, keeping this size below 32-bit allows us to use decoding techniques
+// like 16-bit moves into the third quadrant on some architectures, and keeps
+// the code less complex. 32-bit have always been enough for CDS+class space.
+static constexpr size_t max_klass_range_size = 4 * G;
 
 #ifdef _LP64
 
-#ifdef ASSERT
-void CompressedKlassPointers::assert_is_valid_encoding(address addr, size_t len, address base, int shift) {
-  assert(base + nth_bit(32 + shift) >= addr + len, "Encoding (base=" PTR_FORMAT ", shift=%d) does not "
-         "fully cover the class range " PTR_FORMAT "-" PTR_FORMAT, p2i(base), shift, p2i(addr), p2i(addr + len));
+void CompressedKlassPointers::pre_initialize() {
+  if (UseCompactObjectHeaders) {
+    _tiny_cp = 1;
+    _narrow_klass_pointer_bits = narrow_klass_pointer_bits_tinycp;
+    _max_shift = max_shift_tinycp;
+  } else {
+    _tiny_cp = 0;
+    _narrow_klass_pointer_bits = narrow_klass_pointer_bits_legacy;
+    _max_shift = max_shift_legacy;
+  }
 }
+
+#ifdef ASSERT
+void CompressedKlassPointers::sanity_check_after_initialization() {
+  // In expectation of an assert, prepare condensed info to be printed with the assert.
+  char tmp[256];
+  os::snprintf(tmp, sizeof(tmp), PTR_FORMAT " " PTR_FORMAT " " PTR_FORMAT " %d " SIZE_FORMAT " %u %u",
+      p2i(_klass_range_start), p2i(_klass_range_end), p2i(_base), _shift, _range,
+      _lowest_valid_narrow_klass_id, _highest_valid_narrow_klass_id);
+#define ASSERT_HERE(cond) assert(cond, " (%s)", tmp);
+#define ASSERT_HERE_2(cond, msg) assert(cond, msg " (%s)", tmp);
+
+  // There is no technical reason preventing us from using other klass pointer bit lengths,
+  // but it should be a deliberate choice
+  ASSERT_HERE(_narrow_klass_pointer_bits == 32 || _narrow_klass_pointer_bits == 22);
+
+  // All values must be inited
+  ASSERT_HERE(_max_shift != -1);
+  ASSERT_HERE(_klass_range_start != (address)-1);
+  ASSERT_HERE(_klass_range_end != (address)-1);
+  ASSERT_HERE(_lowest_valid_narrow_klass_id != (narrowKlass)-1);
+  ASSERT_HERE(_base != (address)-1);
+  ASSERT_HERE(_shift != -1);
+  ASSERT_HERE(_range != (size_t)-1);
+
+  const size_t klab = klass_alignment_in_bytes();
+  ASSERT_HERE(klab >= sizeof(uint64_t) && klab <= K);
+
+  // Check that Klass range is fully engulfed in the encoding range
+  ASSERT_HERE(_klass_range_end > _klass_range_start);
+
+  const address encoding_end = _base + nth_bit(narrow_klass_pointer_bits() + _shift);
+  ASSERT_HERE_2(_klass_range_start >= _base && _klass_range_end <= encoding_end,
+                "Resulting encoding range does not fully cover the class range");
+
+  // Check that Klass range is aligned to Klass alignment. That should never be an issue since we mmap the
+  // relevant regions and klass alignment - tied to smallest metachunk size of 1K - will always be smaller
+  // than smallest page size of 4K.
+  ASSERT_HERE_2(is_aligned(_klass_range_start, klab) && is_aligned(_klass_range_end, klab),
+                "Klass range must start at a properly aligned address");
+
+  // Check that lowest and highest possible narrowKlass values make sense
+  ASSERT_HERE_2(_lowest_valid_narrow_klass_id > 0, "Null is not a valid narrowKlass");
+  ASSERT_HERE(_highest_valid_narrow_klass_id > _lowest_valid_narrow_klass_id);
+
+  Klass* k1 = decode_not_null_without_asserts(_lowest_valid_narrow_klass_id, _base, _shift);
+  ASSERT_HERE_2((address)k1 == _klass_range_start + klab, "Not lowest");
+  narrowKlass nk1 = encode_not_null_without_asserts(k1, _base, _shift);
+  ASSERT_HERE_2(nk1 == _lowest_valid_narrow_klass_id, "not reversible");
+
+  Klass* k2 = decode_not_null_without_asserts(_highest_valid_narrow_klass_id, _base, _shift);
+  // _highest_valid_narrow_klass_id must be decoded to the highest theoretically possible
+  // valid Klass* position in range, if we assume minimal Klass size
+  ASSERT_HERE((address)k2 < _klass_range_end);
+  ASSERT_HERE_2(align_up(((address)k2 + sizeof(Klass)), klab) >= _klass_range_end, "Not highest");
+  narrowKlass nk2 = encode_not_null_without_asserts(k2, _base, _shift);
+  ASSERT_HERE_2(nk2 == _highest_valid_narrow_klass_id, "not reversible");
+
+#ifdef AARCH64
+  // On aarch64, we never expect a shift value > 0 in legacy mode
+  ASSERT_HERE_2(tiny_classpointer_mode() || _shift == 0, "Shift > 0 in legacy mode?");
 #endif
+#undef ASSERT_HERE
+#undef ASSERT_HERE_2
+}
+
+void CompressedKlassPointers::calc_lowest_highest_narrow_klass_id() {
+  // Given a Klass range, calculate lowest and highest narrowKlass.
+  const size_t klab = klass_alignment_in_bytes();
+  // Note that 0 is not a valid narrowKlass, and Metaspace prevents us for that reason from allocating at
+  // the very start of class space. So the very first valid Klass position is start-of-range + klab.
+  _lowest_valid_narrow_klass_id =
+      (narrowKlass) (((uintptr_t)(_klass_range_start - _base) + klab) >> _shift);
+  address highest_possible_klass = align_down(_klass_range_end - sizeof(Klass), klab);
+  _highest_valid_narrow_klass_id = (narrowKlass) ((uintptr_t)(highest_possible_klass - _base) >> _shift);
+}
+#endif // ASSERT
 
 // Given a klass range [addr, addr+len) and a given encoding scheme, assert that this scheme covers the range, then
 // set this encoding scheme. Used by CDS at runtime to re-instate the scheme used to pre-compute klass ids for
 // archived heap objects.
 void CompressedKlassPointers::initialize_for_given_encoding(address addr, size_t len, address requested_base, int requested_shift) {
   address const end = addr + len;
 
-  const int narrow_klasspointer_bits = sizeof(narrowKlass) * 8;
-  const size_t encoding_range_size = nth_bit(narrow_klasspointer_bits + requested_shift);
+  if (len > max_klass_range_size) {
+    // Class space size is limited to 3G. This can theoretically happen if the CDS archive
+    // is larger than 1G and class space size is set to the maximum possible 3G.
+    vm_exit_during_initialization("Sum of CDS archive size and class space size exceed 4 GB");
+  }
+
+  const size_t encoding_range_size = nth_bit(narrow_klass_pointer_bits() + requested_shift);
   address encoding_range_end = requested_base + encoding_range_size;
 
   // Note: it would be technically valid for the encoding base to precede the start of the Klass range. But we only call
   // this function from CDS, and therefore know this to be true.
   assert(requested_base == addr, "Invalid requested base");
-  assert(encoding_range_end >= end, "Encoding does not cover the full Klass range");
 
   _base = requested_base;
   _shift = requested_shift;
   _range = encoding_range_size;
 
-  DEBUG_ONLY(assert_is_valid_encoding(addr, len, _base, _shift);)
+#ifdef ASSERT
+  _klass_range_start = addr;
+  _klass_range_end = addr + len;
+  calc_lowest_highest_narrow_klass_id();
+  sanity_check_after_initialization();
+#endif
+
+  DEBUG_ONLY(sanity_check_after_initialization();)
 }
 
 char* CompressedKlassPointers::reserve_address_space_X(uintptr_t from, uintptr_t to, size_t size, size_t alignment, bool aslr) {
   alignment = MAX2(Metaspace::reserve_alignment(), alignment);
   return os::attempt_reserve_memory_between((char*)from, (char*)to, size, alignment, aslr);
 }
 
 char* CompressedKlassPointers::reserve_address_space_for_unscaled_encoding(size_t size, bool aslr) {
-  return reserve_address_space_X(0, nth_bit(32), size, Metaspace::reserve_alignment(), aslr);
+  const size_t unscaled_max = nth_bit(narrow_klass_pointer_bits());
+  return reserve_address_space_X(0, unscaled_max, size, Metaspace::reserve_alignment(), aslr);
 }
 
 char* CompressedKlassPointers::reserve_address_space_for_zerobased_encoding(size_t size, bool aslr) {
-  return reserve_address_space_X(nth_bit(32), nth_bit(32 + LogKlassAlignmentInBytes), size, Metaspace::reserve_alignment(), aslr);
+  const size_t unscaled_max = nth_bit(narrow_klass_pointer_bits());
+  const size_t zerobased_max = nth_bit(narrow_klass_pointer_bits() + max_shift());
+  return reserve_address_space_X(unscaled_max, zerobased_max, size, Metaspace::reserve_alignment(), aslr);
 }
 
 char* CompressedKlassPointers::reserve_address_space_for_16bit_move(size_t size, bool aslr) {
   return reserve_address_space_X(nth_bit(32), nth_bit(48), size, nth_bit(32), aslr);
 }
 
-#if !defined(AARCH64) || defined(ZERO)
-// On aarch64 we have an own version; all other platforms use the default version
 void CompressedKlassPointers::initialize(address addr, size_t len) {
-  // The default version of this code tries, in order of preference:
-  // -unscaled    (base=0 shift=0)
-  // -zero-based  (base=0 shift>0)
-  // -nonzero-base (base>0 shift=0)
-  // Note that base>0 shift>0 should never be needed, since the klass range will
-  // never exceed 4GB.
-  constexpr uintptr_t unscaled_max = nth_bit(32);
-  assert(len <= unscaled_max, "Klass range larger than 32 bits?");
 
-  constexpr uintptr_t zerobased_max = nth_bit(32 + LogKlassAlignmentInBytes);
+  if (len > max_klass_range_size) {
+    // Class space size is limited to 3G. This can theoretically happen if the CDS archive
+    // is larger than 1G and class space size is set to the maximum possible 3G.
+    vm_exit_during_initialization("Sum of CDS archive size and class space size exceed 4 GB");
+  }
+
+  // Give CPU a shot at a specialized init sequence
+#ifndef ZERO
+  if (pd_initialize(addr, len)) {
+    return;
+  }
+#endif
+
+  if (tiny_classpointer_mode()) {
+
+    // This handles the case that we - experimentally - reduce the number of
+    // class pointer bits further, such that (shift + num bits) < 32.
+    assert(len <= (size_t)nth_bit(narrow_klass_pointer_bits() + max_shift()),
+           "klass range size exceeds encoding");
+
+    // In tiny classpointer mode, we don't attempt for zero-based mode.
+    // Instead, we set the base to the start of the klass range and then try
+    // for the smallest shift possible that still covers the whole range.
+    // The reason is that we want to avoid, if possible, shifts larger than
+    // a cacheline size.
+    _base = addr;
+    _range = len;
+
+    if (TinyClassPointerShift != 0) {
+      _shift = TinyClassPointerShift;
+    } else {
+      constexpr int log_cacheline = 6;
+      int s = max_shift();
+      while (s > log_cacheline && ((size_t)nth_bit(narrow_klass_pointer_bits() + s - 1) > len)) {
+        s--;
+      }
+      _shift = s;
+    }
 
-  address const end = addr + len;
-  if (end <= (address)unscaled_max) {
-    _base = nullptr;
-    _shift = 0;
   } else {
-    if (end <= (address)zerobased_max) {
+
+    // In legacy mode, we try, in order of preference:
+    // -unscaled    (base=0 shift=0)
+    // -zero-based  (base=0 shift>0)
+    // -nonzero-base (base>0 shift=0)
+    // Note that base>0 shift>0 should never be needed, since the klass range will
+    // never exceed 4GB.
+    const uintptr_t unscaled_max = nth_bit(narrow_klass_pointer_bits());
+    const uintptr_t zerobased_max = nth_bit(narrow_klass_pointer_bits() + max_shift());
+
+    address const end = addr + len;
+    if (end <= (address)unscaled_max) {
       _base = nullptr;
-      _shift = LogKlassAlignmentInBytes;
-    } else {
-      _base = addr;
       _shift = 0;
+    } else {
+      if (end <= (address)zerobased_max) {
+        _base = nullptr;
+        _shift = max_shift();
+      } else {
+        _base = addr;
+        _shift = 0;
+      }
     }
+    _range = end - _base;
+
   }
-  _range = end - _base;
 
-  DEBUG_ONLY(assert_is_valid_encoding(addr, len, _base, _shift);)
+#ifdef ASSERT
+  _klass_range_start = addr;
+  _klass_range_end = addr + len;
+  calc_lowest_highest_narrow_klass_id();
+  sanity_check_after_initialization();
+#endif
 }
-#endif // !AARCH64 || ZERO
 
 void CompressedKlassPointers::print_mode(outputStream* st) {
+  st->print_cr("UseCompressedClassPointers %d, UseCompactObjectHeaders %d, "
+               "narrow klass pointer bits %d, max shift %d",
+               UseCompressedClassPointers, UseCompactObjectHeaders,
+               _narrow_klass_pointer_bits, _max_shift);
+  if (_base == (address)-1) {
+    st->print_cr("Narrow klass encoding not initialized");
+    return;
+  }
   st->print_cr("Narrow klass base: " PTR_FORMAT ", Narrow klass shift: %d, "
                "Narrow klass range: " SIZE_FORMAT_X, p2i(base()), shift(),
                range());
+#ifdef ASSERT
+  st->print_cr("Klass range: [" PTR_FORMAT "," PTR_FORMAT ")",
+               p2i(_klass_range_start), p2i(_klass_range_end));
+  st->print_cr("Lowest valid nklass id: %u Highest valid nklass id: %u",
+               _lowest_valid_narrow_klass_id, _highest_valid_narrow_klass_id);
+#endif
 }
 
 #endif // _LP64
